Index: cards/CMS_PhaseII/CMS_PhaseII_0PU.tcl
===================================================================
--- cards/CMS_PhaseII/CMS_PhaseII_0PU.tcl	(revision efc1546dedd959a99ddebf277f0757fdb2cf10ea)
+++ cards/CMS_PhaseII/CMS_PhaseII_0PU.tcl	(revision c0756c491b0c61e4c4abbb09afc2d7633f477155)
@@ -29,4 +29,6 @@
   HCal
 
+  PhotonEnergySmearing
+
   TowerMerger
   EFlowMerger
@@ -50,4 +52,5 @@
   GenJetFinder
   FastJetFinder
+  FatJetFinder
 
   ScalarHT
@@ -435,4 +438,18 @@
 }
 
+#################################
+# Energy resolution for electrons
+#################################
+
+module EnergySmearing PhotonEnergySmearing {
+  set InputArray ECal/eflowPhotons
+  set OutputArray eflowPhotons
+
+  # adding 1% extra photon smearing
+  set ResolutionFormula {energy*0.01}
+
+}
+
+
 ####################
 # Energy flow merger
@@ -442,5 +459,5 @@
 # add InputArray InputArray
   add InputArray HCal/eflowTracks
-  add InputArray ECal/eflowPhotons
+  add InputArray PhotonEnergySmearing/eflowPhotons
   add InputArray HCal/eflowNeutralHadrons
   set OutputArray eflow
@@ -537,4 +554,43 @@
 }
 
+
+
+
+############
+# Jet finder
+############
+
+module FastJetFinder FatJetFinder {
+#  set InputArray TowerMerger/towers
+  set InputArray EFlowMerger/eflow
+
+  set OutputArray jets
+
+  set JetAlgorithm 5
+  set ParameterR 0.8
+
+  set ComputeNsubjettiness 1
+  set Beta 1.0
+  set AxisMode 4
+ 
+  set ComputeTrimming 1
+  set RTrim 0.2
+  set PtFracTrim 0.05
+
+  set ComputePruning 1 
+  set ZcutPrun 0.1
+  set RcutPrun 0.5
+  set RPrun 0.8
+
+  set ComputeSoftDrop 1
+  set BetaSoftDrop 0.0
+  set SymmetryCutSoftDrop 0.1
+  set R0SoftDrop 0.8
+
+  set JetPTMin 200.0
+}
+
+
+
 ##################
 # Jet Energy Scale
@@ -556,5 +612,5 @@
   
   # particle for which calculate the isolation
-  set CandidateInputArray ECal/eflowPhotons
+  set CandidateInputArray PhotonEnergySmearing/eflowPhotons
   
   # isolation collection
@@ -801,5 +857,5 @@
 
   add Branch HCal/eflowTracks EFlowTrack Track
-  add Branch ECal/eflowPhotons EFlowPhoton Tower
+  add Branch PhotonEnergySmearing/eflowPhotons EFlowPhoton Tower
   add Branch HCal/eflowNeutralHadrons EFlowNeutralHadron Tower
   
@@ -810,4 +866,5 @@
   
   add Branch JetEnergyScale/jets Jet Jet
+  add Branch FatJetFinder/jets FatJet Jet
   
   add Branch MissingET/momentum MissingET MissingET
Index: cards/CMS_PhaseII/CMS_PhaseII_200PU.tcl
===================================================================
--- cards/CMS_PhaseII/CMS_PhaseII_200PU.tcl	(revision efc1546dedd959a99ddebf277f0757fdb2cf10ea)
+++ cards/CMS_PhaseII/CMS_PhaseII_200PU.tcl	(revision c0756c491b0c61e4c4abbb09afc2d7633f477155)
@@ -30,5 +30,6 @@
   ECal
   HCal
-
+  
+  PhotonEnergySmearing
   ElectronFilter
   TrackPileUpSubtractor
@@ -65,4 +66,5 @@
   GenJetFinder
   FastJetFinder
+  FatJetFinder
 
   ScalarHT
@@ -96,5 +98,6 @@
 
   # pre-generated minbias input file
-  set PileUpFile ../eos/cms/store/group/upgrade/delphes/PhaseII/MinBias_100k.pileup
+  #set PileUpFile ../eos/cms/store/group/upgrade/delphes/PhaseII/MinBias_100k.pileup
+  set PileUpFile MinBias.pileup
 
   # average expected pile up
@@ -464,4 +467,19 @@
 }
 
+#################################
+# Energy resolution for electrons
+#################################
+
+module EnergySmearing PhotonEnergySmearing {
+  set InputArray ECal/eflowPhotons
+  set OutputArray eflowPhotons
+
+  # adding 1% extra photon smearing
+  set ResolutionFormula {energy*0.01}
+
+}
+
+
+
 #################
 # Electron filter
@@ -512,5 +530,5 @@
 module Merger NeutralEFlowMerger {
 # add InputArray InputArray
-  add InputArray ECal/eflowPhotons
+  add InputArray PhotonEnergySmearing/eflowPhotons
   add InputArray HCal/eflowNeutralHadrons
   set OutputArray eflowTowers
@@ -525,5 +543,5 @@
 # add InputArray InputArray
   add InputArray HCal/eflowTracks
-  add InputArray ECal/eflowPhotons
+  add InputArray PhotonEnergySmearing/eflowPhotons
   add InputArray HCal/eflowNeutralHadrons
   set OutputArray eflow
@@ -537,5 +555,5 @@
 # add InputArray InputArray
   add InputArray TrackMerger/tracks
-  add InputArray ECal/eflowPhotons
+  add InputArray PhotonEnergySmearing/eflowPhotons
   add InputArray HCal/eflowNeutralHadrons
   set OutputArray eflow
@@ -708,4 +726,41 @@
 }
 
+
+
+############
+# Jet finder
+############
+
+module FastJetFinder FatJetFinder {
+#  set InputArray TowerMerger/towers
+  set InputArray RunPUPPI/PuppiParticles
+
+  set OutputArray jets
+
+  set JetAlgorithm 5
+  set ParameterR 0.8
+
+  set ComputeNsubjettiness 1
+  set Beta 1.0
+  set AxisMode 4
+
+  set ComputeTrimming 1
+  set RTrim 0.2
+  set PtFracTrim 0.05
+
+  set ComputePruning 1
+  set ZcutPrun 0.1
+  set RcutPrun 0.5
+  set RPrun 0.8
+
+  set ComputeSoftDrop 1
+  set BetaSoftDrop 0.0
+  set SymmetryCutSoftDrop 0.1
+  set R0SoftDrop 0.8
+
+  set JetPTMin 200.0
+}
+
+
 ##################
 # Jet Energy Scale
@@ -726,5 +781,5 @@
 
 module PdgCodeFilter PhotonFilter {
-  set InputArray ECal/eflowPhotons
+  set InputArray PhotonEnergySmearing/eflowPhotons
   set OutputArray photons
   set Invert true
@@ -1016,4 +1071,5 @@
 
   add Branch JetEnergyScale/jets Jet Jet
+  add Branch FatJetFinder/jets FatJet Jet
 
   add Branch MissingET/momentum MissingET MissingET
